Bug 915280 - Crash in nfs with getfacl
Crash in nfs with getfacl
Status: CLOSED CURRENTRELEASE
Product: GlusterFS
Classification: Community
Component: nfs (Show other bugs)
mainline
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Vijay Bellur
:
Depends On:
Blocks: 895528
  Show dependency treegraph
 
Reported: 2013-02-25 06:29 EST by Vijay Bellur
Modified: 2013-07-24 13:08 EDT (History)
2 users (show)

See Also:
Fixed In Version: glusterfs-3.4.0
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-07-24 13:08:58 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Vijay Bellur 2013-02-25 06:29:44 EST
Description of problem:

The following crash is seen when getfacl is done on a file and stat on the file fails for any reason:

#0  0x00007f8b80989dbd in acl3_stat_cbk (frame=<optimized out>, cookie=<optimized out>, this=<optimized out>, op_ret=<optimized out>, op_errno=13, buf=<optimized out>, xdata=0x0)
    at ../../../../../xlators/nfs/server/src/acl3.c:307
#1  0x00007f8b8095f182 in STACK_DESTROY (stack=0xd) at ../../../../../libglusterfs/src/stack.h:174
#2  nfs_fop_fstat_cbk (frame=<optimized out>, cookie=<optimized out>, this=<optimized out>, op_ret=<optimized out>, op_errno=<optimized out>, buf=<optimized out>, xdata=0x0)
    at ../../../../../xlators/nfs/server/src/nfs-fops.c:552
#3  0x00007f8b80bb35fb in io_stats_stat_cbk (frame=0x7f8b840c258c, cookie=<optimized out>, this=<optimized out>, op_ret=-1, op_errno=13, buf=0x0, xdata=0x0)
    at ../../../../../xlators/debug/io-stats/src/io-stats.c:1311
#4  0x00007f8b80dc88db in error_gen_stat (frame=0x7f8b840c2638, this=<optimized out>, loc=<optimized out>, xdata=0x0) at ../../../../../xlators/debug/error-gen/src/error-gen.c:444
#5  0x00007f8b80ba979d in io_stats_stat (frame=0x7f8b840c258c, this=0x201cd00, loc=0x7f8b7a1de414, xdata=0x0) at ../../../../../xlators/debug/io-stats/src/io-stats.c:1877
#6  0x00007f8b80960423 in nfs_fop_stat (nfsx=<optimized out>, xl=0x201cd00, nfu=<optimized out>, loc=0x7f8b7a1de414, cbk=0x7f8b80989c50 <acl3_getacl_resume+344>, local=0x7f8b7a1de02c)
    at ../../../../../xlators/nfs/server/src/nfs-fops.c:526
#7  0x00007f8b80989afd in acl3_getacl_resume (carg=0x7f8b7a1de02c) at ../../../../../xlators/nfs/server/src/acl3.c:324
#8  0x00007f8b8506a488 in ?? () from /usr/local/lib/libgfrpc.so.0
#9  0x0000000000000000 in ?? ()


Version-Release number of selected component (if applicable):
mainline

How reproducible:
Always


Steps to Reproduce:
1. Perform getfacl on a file from nfs mount
2. Ensure that stat on the object fails by unlinking the file from a different client.
3. NFS server crashes
  
Actual results:

NFS server should not crash.


Expected results:


Additional info:
Comment 1 Vijay Bellur 2013-02-26 14:17:41 EST
CHANGE: http://review.gluster.org/4576 (debug/error-gen: Add support for reconfiguring options.) merged in master by Anand Avati (avati@redhat.com)
Comment 2 Vijay Bellur 2013-02-26 14:17:55 EST
CHANGE: http://review.gluster.org/4577 (mgmt/glusterd: Expose error-gen options through volume set.) merged in master by Anand Avati (avati@redhat.com)
Comment 3 Vijay Bellur 2013-02-26 14:18:44 EST
CHANGE: http://review.gluster.org/4578 (nfs/server: Fix multiple crashes in acl handling code.) merged in master by Anand Avati (avati@redhat.com)
Comment 4 Vijay Bellur 2013-03-03 09:21:25 EST
CHANGE: http://review.gluster.org/4606 (nfs/server: Fix multiple crashes in acl handler.) merged in release-3.4 by Vijay Bellur (vbellur@redhat.com)

Note You need to log in before you can comment on or make changes to this bug.